(* ------------------------------------------------------ *)
(*                      SCHUSS.PAS                        *)
(*            Einfache Ermittlung der Zahl Pi             *)
(*        (c) 1993 Dr.Lothar Wenzel & DMV-Verlag          *)
(* ------------------------------------------------------ *)
PROGRAM Schuss;

CONST
  Seite   = 2;        { Seitenlnge des Quadrates = Durchmesser Kreis }
  Anzahl  = 10000000; { Anzahl der Versuche }
  Schritt = 100000;   { Abstand zwischen zwei Pi-Abschtzungen }

VAR
  i       : LongInt;  { Zhlindex }
  x,y     : REAL;     { zuflliger Punkt im Quadrat }
  Summe   : LongInt;  { Anzahl der Treffer im Kreis }

BEGIN
  Summe := 0;
  FOR i := 1 TO Anzahl DO BEGIN
    x := 2*Random;
    y := 2*Random;
    IF ((x - 1)*(x - 1) + (y - 1)*(y - 1) < 1) THEN
      Summe := Succ(Summe);
    IF (i MOD Schritt = 0) THEN
      WriteLn(i:8, 4*(Summe/i)); { Nherung fr Pi }
  END;
  WriteLn;
  WriteLn('Ende der Rechnung.');
  ReadLn;
END.
(* ------------------------------------------------------ *)
(*                 Ende von SCHUSS.PAS                    *)
